'From Squeak3.9 of 7 November 2006 [latest update: #7067] on 2 July 2007 at 1:30:51 pm'!
Object subclass: #Money
	instanceVariableNames: 'currency amount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Money'!
TestCase subclass: #TestMoney
	instanceVariableNames: 'chf2 chf8 chf10'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Money'!

!Money methodsFor: 'as yet unclassified' stamp: 'on 7/2/2007 13:21'!
!!= aMoney
	^ (self = aMoney) not! !

!Money methodsFor: 'as yet unclassified' stamp: 'on 7/2/2007 13:26'!
+ aMoney
	self assert: [ self currency = aMoney currency ].
	^ Money currency: self currency amount: self amount + aMoney amount! !

!Money methodsFor: 'as yet unclassified' stamp: 'on 7/2/2007 13:20'!
= aMoney
	^ self amount = aMoney amount and: [ self currency = aMoney currency ]! !

!Money methodsFor: 'as yet unclassified' stamp: 'on 7/2/2007 13:18'!
amount
	^ amount! !

!Money methodsFor: 'as yet unclassified' stamp: 'on 7/2/2007 13:18'!
amount: aNumber
	amount := aNumber! !

!Money methodsFor: 'as yet unclassified' stamp: 'on 7/2/2007 13:17'!
currency
	^ currency! !

!Money methodsFor: 'as yet unclassified' stamp: 'on 7/2/2007 13:18'!
currency: aString
	currency := aString! !


!Money class methodsFor: 'as yet unclassified' stamp: 'on 7/2/2007 13:23'!
currency: aCurrency amount: anAmount
	^  self new currency: aCurrency; amount: anAmount; yourself! !


!Number methodsFor: '*Money' stamp: 'on 7/2/2007 13:30'!
chf
	^ Money currency: 'CHF' amount: self! !


!TestMoney methodsFor: 'as yet unclassified' stamp: 'on 7/2/2007 13:28'!
setUp
	chf2 := 2 chf.
	chf8 := 8 chf.
	chf10 := 10 chf.! !

!TestMoney methodsFor: 'as yet unclassified' stamp: 'on 7/2/2007 13:25'!
testAdd
	self assert: chf2 + chf8 = chf10
! !

!TestMoney methodsFor: 'as yet unclassified' stamp: 'on 7/2/2007 13:17'!
testEquals
	self assert: chf2 = chf2.
	self assert: chf2 = (Money new currency: 'CHF'; amount: 2).
	self assert: chf2 !!= chf8.
! !


!Number reorganize!
('arithmetic' * + - / // \\ abs arg negated quo: reciprocal rem:)
('comparing' closeTo:)
('converting' printShowingDecimalPlaces: @ adaptToCollection:andSend: adaptToFloat:andSend: adaptToFraction:andSend: adaptToInteger:andSend: adaptToPoint:andSend: adaptToScaledDecimal:andSend: adaptToString:andSend: asB3DVector3 asDuration asFloatD asFloatE asFloatQ asInteger asNumber asPoint asScaledDecimal asScaledDecimal: asSmallAngleDegrees asSmallPositiveDegrees day days degreesToRadians hour hours i milliSecond milliSeconds minute minutes nanoSecond nanoSeconds radiansToDegrees second seconds sign: week weeks)
('filter streaming' byteEncode:)
('intervals' to: to:by: to:by:do: to:do:)
('mathematical functions' arcCos arcSin arcTan arcTan: cos degreeCos degreeSin exp floorLog: interpolateTo:at: ln log log: raisedTo: raisedToInteger: sin sqrt squared tan)
('printing' defaultLabelForInspector isOrAreStringWith: printOn: printOn:base: printString printStringBase: storeOn: storeOn:base: storeStringBase: stringForReadout)
('testing' basicType even isDivisibleBy: isInf isInfinite isNaN isNumber isZero negative odd positive sign strictlyPositive)
('truncation and round off' ceiling detentBy:atMultiplesOf:snap: floor fractionPart integerPart reduce roundTo: roundUpTo: rounded truncateTo: truncated)
('*eToys-printing' newTileMorphRepresentative)
('*eToys-vocabulary' vocabularyDemanded)
('*Morphic-NewCurve-testing' isNonZero)
('*Money' chf)
!

